searchData={"items":[{"type":"module","title":"Teiserver","doc":"Documentation for `Teiserver`.\n\nCopied from Oban and tweaked.","ref":"Teiserver.html"},{"type":"module","title":"Main guides: - Teiserver","doc":"- [Installation](guides/installation.md)\n- [Hello world](guides/hello_world.md)","ref":"Teiserver.html#module-main-guides"},{"type":"module","title":"Contexts - Teiserver","doc":"These are the main modules you will be interacting with in Teiserver. They typically delegate all their functions to something more specific but the context module will be the preferred point of contact with the Teiserver library.","ref":"Teiserver.html#module-contexts"},{"type":"function","title":"Teiserver.config/1","doc":"Retrieve the `Teiserver.Config` struct for a named Teiserver supervision tree.","ref":"Teiserver.html#config/1"},{"type":"function","title":"Example - Teiserver.config/1","doc":"Retrieve the default `Teiserver` instance config:\n\n    %Teiserver.Config{} = Teiserver.config()\n\nRetrieve the config for an instance started with a custom name:\n\n    %Teiserver.Config{} = Teiserver.config(MyCustomTeiserver)","ref":"Teiserver.html#config/1-example"},{"type":"function","title":"Teiserver.start_link/1","doc":"Starts an `Teiserver` supervision tree linked to the current process.","ref":"Teiserver.html#start_link/1"},{"type":"function","title":"Options - Teiserver.start_link/1","doc":"These options are required; without them the supervisor won't start:\n\n* `:repo` — specifies the Ecto repo used to persist data\n\n#","ref":"Teiserver.html#start_link/1-options"},{"type":"function","title":"Primary Options - Teiserver.start_link/1","doc":"These options determine what the system does at a high level, i.e. which queues to run:\n\n* `:log` — either `false` to disable logging or a standard log level (`:error`, `:warning`,\n  `:info`, `:debug`, etc.). This determines whether queries are logged or not; overriding the\n  repo's configured log level. Defaults to `false`, where no queries are logged.\n\n* `:name` — used for supervisor registration, it must be unique across an entire VM instance.\n  Defaults to `Teiserver` when no name is provided.\n\n* `:node` — used to identify the node that the supervision tree is running in. If no value is\n  provided it will use the `node` name in a distributed system, or the `hostname` in an isolated\n  node. See \"Node Name\" below.\n\n* `:prefix` — the query prefix, or schema, to use for inserting and executing jobs. A\n  `settings_site` table must exist within the prefix.","ref":"Teiserver.html#start_link/1-primary-options"},{"type":"function","title":"Example - Teiserver.start_link/1","doc":"Start a stand-alone `Teiserver` instance:\n\n    {:ok, pid} = Teiserver.start_link(repo: MyApp.Repo)\n\nTo start an `Teiserver` instance within an application's supervision tree:\n\n    def start(_type, _args) do\n      children = [MyApp.Repo, {Teiserver, repo: MyApp.Repo}]\n\n      Supervisor.start_link(children, strategy: :one_for_one, name: MyApp.Supervisor)\n    end","ref":"Teiserver.html#start_link/1-example"},{"type":"function","title":"Node Name - Teiserver.start_link/1","doc":"When the `node` value hasn't been configured it is generated based on the environment:\n\n* In a distributed system the node name is used\n* In a Heroku environment the system environment's `DYNO` value is used\n* Otherwise, the system hostname is used","ref":"Teiserver.html#start_link/1-node-name"},{"type":"type","title":"Teiserver.lobby_id/0","doc":"","ref":"Teiserver.html#t:lobby_id/0"},{"type":"type","title":"Teiserver.name/0","doc":"","ref":"Teiserver.html#t:name/0"},{"type":"type","title":"Teiserver.option/0","doc":"","ref":"Teiserver.html#t:option/0"},{"type":"type","title":"Teiserver.party_id/0","doc":"","ref":"Teiserver.html#t:party_id/0"},{"type":"type","title":"Teiserver.user_id/0","doc":"","ref":"Teiserver.html#t:user_id/0"},{"type":"module","title":"Teiserver.Account","doc":"The contextual module for [Users](Teiserver.Account.User), [ExtraUserData](Teiserver.Account.ExtraUserData)","ref":"Teiserver.Account.html"},{"type":"function","title":"Teiserver.Account.change_user/2","doc":"","ref":"Teiserver.Account.html#change_user/2"},{"type":"function","title":"Teiserver.Account.create_user/1","doc":"","ref":"Teiserver.Account.html#create_user/1"},{"type":"function","title":"Teiserver.Account.delete_user/1","doc":"","ref":"Teiserver.Account.html#delete_user/1"},{"type":"function","title":"Teiserver.Account.get_user/2","doc":"","ref":"Teiserver.Account.html#get_user/2"},{"type":"function","title":"Teiserver.Account.get_user!/2","doc":"","ref":"Teiserver.Account.html#get_user!/2"},{"type":"function","title":"Teiserver.Account.get_user_by_id/1","doc":"","ref":"Teiserver.Account.html#get_user_by_id/1"},{"type":"function","title":"Teiserver.Account.get_user_by_name/1","doc":"","ref":"Teiserver.Account.html#get_user_by_name/1"},{"type":"function","title":"Teiserver.Account.list_users/0","doc":"","ref":"Teiserver.Account.html#list_users/0"},{"type":"function","title":"Teiserver.Account.list_users/1","doc":"","ref":"Teiserver.Account.html#list_users/1"},{"type":"function","title":"Teiserver.Account.update_user/2","doc":"","ref":"Teiserver.Account.html#update_user/2"},{"type":"function","title":"Teiserver.Account.verify_user_password/2","doc":"","ref":"Teiserver.Account.html#verify_user_password/2"},{"type":"module","title":"Teiserver.Connections","doc":"The context for all things connection related (mostly clients).","ref":"Teiserver.Connections.html"},{"type":"function","title":"Teiserver.Connections.client_exists?/1","doc":"","ref":"Teiserver.Connections.html#client_exists?/1"},{"type":"function","title":"Teiserver.Connections.get_client/1","doc":"","ref":"Teiserver.Connections.html#get_client/1"},{"type":"function","title":"Teiserver.Connections.list_client_ids/0","doc":"","ref":"Teiserver.Connections.html#list_client_ids/0"},{"type":"function","title":"Teiserver.Connections.login_user/1","doc":"","ref":"Teiserver.Connections.html#login_user/1"},{"type":"module","title":"Teiserver.Settings","doc":"The contextual module for [SiteSetting](Teiserver.Settings.SiteSetting), [UserSetting](Teiserver.Settings.UserSetting)","ref":"Teiserver.Settings.html"},{"type":"function","title":"Teiserver.Settings.change_site_setting/2","doc":"","ref":"Teiserver.Settings.html#change_site_setting/2"},{"type":"function","title":"Teiserver.Settings.change_user_setting/2","doc":"","ref":"Teiserver.Settings.html#change_user_setting/2"},{"type":"function","title":"Teiserver.Settings.create_site_setting/1","doc":"","ref":"Teiserver.Settings.html#create_site_setting/1"},{"type":"function","title":"Teiserver.Settings.create_user_setting/1","doc":"","ref":"Teiserver.Settings.html#create_user_setting/1"},{"type":"function","title":"Teiserver.Settings.delete_site_setting/1","doc":"","ref":"Teiserver.Settings.html#delete_site_setting/1"},{"type":"function","title":"Teiserver.Settings.delete_user_setting/1","doc":"","ref":"Teiserver.Settings.html#delete_user_setting/1"},{"type":"function","title":"Teiserver.Settings.get_site_setting/2","doc":"","ref":"Teiserver.Settings.html#get_site_setting/2"},{"type":"function","title":"Teiserver.Settings.get_site_setting!/2","doc":"","ref":"Teiserver.Settings.html#get_site_setting!/2"},{"type":"function","title":"Teiserver.Settings.get_user_setting/2","doc":"","ref":"Teiserver.Settings.html#get_user_setting/2"},{"type":"function","title":"Teiserver.Settings.get_user_setting!/2","doc":"","ref":"Teiserver.Settings.html#get_user_setting!/2"},{"type":"function","title":"Teiserver.Settings.list_site_settings/0","doc":"","ref":"Teiserver.Settings.html#list_site_settings/0"},{"type":"function","title":"Teiserver.Settings.list_site_settings/1","doc":"","ref":"Teiserver.Settings.html#list_site_settings/1"},{"type":"function","title":"Teiserver.Settings.list_user_settings/0","doc":"","ref":"Teiserver.Settings.html#list_user_settings/0"},{"type":"function","title":"Teiserver.Settings.list_user_settings/1","doc":"","ref":"Teiserver.Settings.html#list_user_settings/1"},{"type":"function","title":"Teiserver.Settings.update_site_setting/2","doc":"","ref":"Teiserver.Settings.html#update_site_setting/2"},{"type":"function","title":"Teiserver.Settings.update_user_setting/2","doc":"","ref":"Teiserver.Settings.html#update_user_setting/2"},{"type":"module","title":"Teiserver.Account.ClientServer","doc":"A process representing the state of a client.","ref":"Teiserver.Account.ClientServer.html"},{"type":"function","title":"Teiserver.Account.ClientServer.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Teiserver.Account.ClientServer.html#child_spec/1"},{"type":"function","title":"Teiserver.Account.ClientServer.start_link/1","doc":"","ref":"Teiserver.Account.ClientServer.html#start_link/1"},{"type":"module","title":"Teiserver.Account.ExtraUserData","doc":"A blob of extra key-values for each user. Intended to be used as an easy to\nextend object which doesn't need to be queried quite as often as users.","ref":"Teiserver.Account.ExtraUserData.html"},{"type":"module","title":"Teiserver.Account.UserLib","doc":"Library of user related functions.","ref":"Teiserver.Account.UserLib.html"},{"type":"function","title":"Teiserver.Account.UserLib.change_user/2","doc":"Returns an `%Ecto.Changeset{}` for tracking user changes.","ref":"Teiserver.Account.UserLib.html#change_user/2"},{"type":"function","title":"Examples - Teiserver.Account.UserLib.change_user/2","doc":"iex> change_user(user)\n    %Ecto.Changeset{data: %User{}}","ref":"Teiserver.Account.UserLib.html#change_user/2-examples"},{"type":"function","title":"Teiserver.Account.UserLib.create_user/1","doc":"Creates a user.","ref":"Teiserver.Account.UserLib.html#create_user/1"},{"type":"function","title":"Examples - Teiserver.Account.UserLib.create_user/1","doc":"iex> create_user(%{field: value})\n    {:ok, %User{}}\n\n    iex> create_user(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Teiserver.Account.UserLib.html#create_user/1-examples"},{"type":"function","title":"Teiserver.Account.UserLib.delete_user/1","doc":"Deletes a user.","ref":"Teiserver.Account.UserLib.html#delete_user/1"},{"type":"function","title":"Examples - Teiserver.Account.UserLib.delete_user/1","doc":"iex> delete_user(user)\n    {:ok, %User{}}\n\n    iex> delete_user(user)\n    {:error, %Ecto.Changeset{}}","ref":"Teiserver.Account.UserLib.html#delete_user/1-examples"},{"type":"function","title":"Teiserver.Account.UserLib.get_user/2","doc":"Gets a single user.\n\nReturns nil if the User does not exist.","ref":"Teiserver.Account.UserLib.html#get_user/2"},{"type":"function","title":"Examples - Teiserver.Account.UserLib.get_user/2","doc":"iex> get_user(123)\n    %User{}\n\n    iex> get_user(456)\n    nil","ref":"Teiserver.Account.UserLib.html#get_user/2-examples"},{"type":"function","title":"Teiserver.Account.UserLib.get_user!/2","doc":"Gets a single user.\n\nRaises `Ecto.NoResultsError` if the User does not exist.","ref":"Teiserver.Account.UserLib.html#get_user!/2"},{"type":"function","title":"Examples - Teiserver.Account.UserLib.get_user!/2","doc":"iex> get_user!(123)\n    %User{}\n\n    iex> get_user!(456)\n    ** (Ecto.NoResultsError)","ref":"Teiserver.Account.UserLib.html#get_user!/2-examples"},{"type":"function","title":"Teiserver.Account.UserLib.get_user_by_id/1","doc":"","ref":"Teiserver.Account.UserLib.html#get_user_by_id/1"},{"type":"function","title":"Teiserver.Account.UserLib.get_user_by_name/1","doc":"","ref":"Teiserver.Account.UserLib.html#get_user_by_name/1"},{"type":"function","title":"Teiserver.Account.UserLib.list_users/1","doc":"Returns the list of users.","ref":"Teiserver.Account.UserLib.html#list_users/1"},{"type":"function","title":"Examples - Teiserver.Account.UserLib.list_users/1","doc":"iex> list_users()\n    [%User{}, ...]","ref":"Teiserver.Account.UserLib.html#list_users/1-examples"},{"type":"function","title":"Teiserver.Account.UserLib.update_user/2","doc":"Updates a user.","ref":"Teiserver.Account.UserLib.html#update_user/2"},{"type":"function","title":"Examples - Teiserver.Account.UserLib.update_user/2","doc":"iex> update_user(user, %{field: new_value})\n    {:ok, %User{}}\n\n    iex> update_user(user, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Teiserver.Account.UserLib.html#update_user/2-examples"},{"type":"function","title":"Teiserver.Account.UserLib.verify_user_password/2","doc":"Takes a user, a plaintext password and returns a boolean if the password is\ncorrect for the user. Note it does this via a secure method to prevent timing\nattacks, never manually verify the password with standard string comparison.","ref":"Teiserver.Account.UserLib.html#verify_user_password/2"},{"type":"module","title":"Teiserver.Connections.Client","doc":"A client represents the logged in instance of a user. Clients are not persisted in the database","ref":"Teiserver.Connections.Client.html"},{"type":"function","title":"Teiserver.Connections.Client.new/1","doc":"","ref":"Teiserver.Connections.Client.html#new/1"},{"type":"type","title":"Teiserver.Connections.Client.t/0","doc":"","ref":"Teiserver.Connections.Client.html#t:t/0"},{"type":"module","title":"Teiserver.Connections.ClientLib","doc":"Library of client related functions.","ref":"Teiserver.Connections.ClientLib.html"},{"type":"function","title":"Teiserver.Connections.ClientLib.client_exists?/1","doc":"Tells us if the client exists right now or not.","ref":"Teiserver.Connections.ClientLib.html#client_exists?/1"},{"type":"function","title":"Teiserver.Connections.ClientLib.get_client/1","doc":"Gets a single client.\n\nReturns nil if the Client does not exist.","ref":"Teiserver.Connections.ClientLib.html#get_client/1"},{"type":"function","title":"Examples - Teiserver.Connections.ClientLib.get_client/1","doc":"iex> get_client(123)\n    %Client{}\n\n    iex> get_client(456)\n    nil","ref":"Teiserver.Connections.ClientLib.html#get_client/1-examples"},{"type":"function","title":"Teiserver.Connections.ClientLib.list_client_ids/0","doc":"Returns the list of client ids.","ref":"Teiserver.Connections.ClientLib.html#list_client_ids/0"},{"type":"function","title":"Examples - Teiserver.Connections.ClientLib.list_client_ids/0","doc":"iex> list_client_ids()\n    [123, ...]","ref":"Teiserver.Connections.ClientLib.html#list_client_ids/0-examples"},{"type":"function","title":"Teiserver.Connections.ClientLib.login_user/1","doc":"Given a user, log them in. If the user already exists as a client then no new\nlogin process is performed but the client details are still returned.","ref":"Teiserver.Connections.ClientLib.html#login_user/1"},{"type":"module","title":"Teiserver.Settings.SiteSettingLib","doc":"Library of site_setting related functions.","ref":"Teiserver.Settings.SiteSettingLib.html"},{"type":"function","title":"Teiserver.Settings.SiteSettingLib.change_site_setting/2","doc":"Returns an `%Ecto.Changeset{}` for tracking site_setting changes.","ref":"Teiserver.Settings.SiteSettingLib.html#change_site_setting/2"},{"type":"function","title":"Examples - Teiserver.Settings.SiteSettingLib.change_site_setting/2","doc":"iex> change_site_setting(site_setting)\n    %Ecto.Changeset{data: %SiteSetting{}}","ref":"Teiserver.Settings.SiteSettingLib.html#change_site_setting/2-examples"},{"type":"function","title":"Teiserver.Settings.SiteSettingLib.create_site_setting/1","doc":"Creates a site_setting.","ref":"Teiserver.Settings.SiteSettingLib.html#create_site_setting/1"},{"type":"function","title":"Examples - Teiserver.Settings.SiteSettingLib.create_site_setting/1","doc":"iex> create_site_setting(%{field: value})\n    {:ok, %SiteSetting{}}\n\n    iex> create_site_setting(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Teiserver.Settings.SiteSettingLib.html#create_site_setting/1-examples"},{"type":"function","title":"Teiserver.Settings.SiteSettingLib.delete_site_setting/1","doc":"Deletes a site_setting.","ref":"Teiserver.Settings.SiteSettingLib.html#delete_site_setting/1"},{"type":"function","title":"Examples - Teiserver.Settings.SiteSettingLib.delete_site_setting/1","doc":"iex> delete_site_setting(site_setting)\n    {:ok, %SiteSetting{}}\n\n    iex> delete_site_setting(site_setting)\n    {:error, %Ecto.Changeset{}}","ref":"Teiserver.Settings.SiteSettingLib.html#delete_site_setting/1-examples"},{"type":"function","title":"Teiserver.Settings.SiteSettingLib.get_site_setting/2","doc":"Gets a single site_setting.\n\nReturns nil if the SiteSetting does not exist.","ref":"Teiserver.Settings.SiteSettingLib.html#get_site_setting/2"},{"type":"function","title":"Examples - Teiserver.Settings.SiteSettingLib.get_site_setting/2","doc":"iex> get_site_setting(123)\n    %SiteSetting{}\n\n    iex> get_site_setting(456)\n    nil","ref":"Teiserver.Settings.SiteSettingLib.html#get_site_setting/2-examples"},{"type":"function","title":"Teiserver.Settings.SiteSettingLib.get_site_setting!/2","doc":"Gets a single site_setting.\n\nRaises `Ecto.NoResultsError` if the SiteSetting does not exist.","ref":"Teiserver.Settings.SiteSettingLib.html#get_site_setting!/2"},{"type":"function","title":"Examples - Teiserver.Settings.SiteSettingLib.get_site_setting!/2","doc":"iex> get_site_setting!(123)\n    %SiteSetting{}\n\n    iex> get_site_setting!(456)\n    ** (Ecto.NoResultsError)","ref":"Teiserver.Settings.SiteSettingLib.html#get_site_setting!/2-examples"},{"type":"function","title":"Teiserver.Settings.SiteSettingLib.list_site_settings/1","doc":"Returns the list of site_settings.","ref":"Teiserver.Settings.SiteSettingLib.html#list_site_settings/1"},{"type":"function","title":"Examples - Teiserver.Settings.SiteSettingLib.list_site_settings/1","doc":"iex> list_site_settings()\n    [%SiteSetting{}, ...]","ref":"Teiserver.Settings.SiteSettingLib.html#list_site_settings/1-examples"},{"type":"function","title":"Teiserver.Settings.SiteSettingLib.update_site_setting/2","doc":"Updates a site_setting.","ref":"Teiserver.Settings.SiteSettingLib.html#update_site_setting/2"},{"type":"function","title":"Examples - Teiserver.Settings.SiteSettingLib.update_site_setting/2","doc":"iex> update_site_setting(site_setting, %{field: new_value})\n    {:ok, %SiteSetting{}}\n\n    iex> update_site_setting(site_setting, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Teiserver.Settings.SiteSettingLib.html#update_site_setting/2-examples"},{"type":"module","title":"Teiserver.Settings.UserSettingLib","doc":"Library of user_setting related functions.","ref":"Teiserver.Settings.UserSettingLib.html"},{"type":"function","title":"Teiserver.Settings.UserSettingLib.change_user_setting/2","doc":"Returns an `%Ecto.Changeset{}` for tracking user_setting changes.","ref":"Teiserver.Settings.UserSettingLib.html#change_user_setting/2"},{"type":"function","title":"Examples - Teiserver.Settings.UserSettingLib.change_user_setting/2","doc":"iex> change_user_setting(user_setting)\n    %Ecto.Changeset{data: %UserSetting{}}","ref":"Teiserver.Settings.UserSettingLib.html#change_user_setting/2-examples"},{"type":"function","title":"Teiserver.Settings.UserSettingLib.create_user_setting/1","doc":"Creates a user_setting.","ref":"Teiserver.Settings.UserSettingLib.html#create_user_setting/1"},{"type":"function","title":"Examples - Teiserver.Settings.UserSettingLib.create_user_setting/1","doc":"iex> create_user_setting(%{field: value})\n    {:ok, %UserSetting{}}\n\n    iex> create_user_setting(%{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Teiserver.Settings.UserSettingLib.html#create_user_setting/1-examples"},{"type":"function","title":"Teiserver.Settings.UserSettingLib.delete_user_setting/1","doc":"Deletes a user_setting.","ref":"Teiserver.Settings.UserSettingLib.html#delete_user_setting/1"},{"type":"function","title":"Examples - Teiserver.Settings.UserSettingLib.delete_user_setting/1","doc":"iex> delete_user_setting(user_setting)\n    {:ok, %UserSetting{}}\n\n    iex> delete_user_setting(user_setting)\n    {:error, %Ecto.Changeset{}}","ref":"Teiserver.Settings.UserSettingLib.html#delete_user_setting/1-examples"},{"type":"function","title":"Teiserver.Settings.UserSettingLib.get_user_setting/2","doc":"Gets a single user_setting.\n\nReturns nil if the UserSetting does not exist.","ref":"Teiserver.Settings.UserSettingLib.html#get_user_setting/2"},{"type":"function","title":"Examples - Teiserver.Settings.UserSettingLib.get_user_setting/2","doc":"iex> get_user_setting(123)\n    %UserSetting{}\n\n    iex> get_user_setting(456)\n    nil","ref":"Teiserver.Settings.UserSettingLib.html#get_user_setting/2-examples"},{"type":"function","title":"Teiserver.Settings.UserSettingLib.get_user_setting!/2","doc":"Gets a single user_setting.\n\nRaises `Ecto.NoResultsError` if the UserSetting does not exist.","ref":"Teiserver.Settings.UserSettingLib.html#get_user_setting!/2"},{"type":"function","title":"Examples - Teiserver.Settings.UserSettingLib.get_user_setting!/2","doc":"iex> get_user_setting!(123)\n    %UserSetting{}\n\n    iex> get_user_setting!(456)\n    ** (Ecto.NoResultsError)","ref":"Teiserver.Settings.UserSettingLib.html#get_user_setting!/2-examples"},{"type":"function","title":"Teiserver.Settings.UserSettingLib.list_user_settings/1","doc":"Returns the list of user_settings.","ref":"Teiserver.Settings.UserSettingLib.html#list_user_settings/1"},{"type":"function","title":"Examples - Teiserver.Settings.UserSettingLib.list_user_settings/1","doc":"iex> list_user_settings()\n    [%UserSetting{}, ...]","ref":"Teiserver.Settings.UserSettingLib.html#list_user_settings/1-examples"},{"type":"function","title":"Teiserver.Settings.UserSettingLib.update_user_setting/2","doc":"Updates a user_setting.","ref":"Teiserver.Settings.UserSettingLib.html#update_user_setting/2"},{"type":"function","title":"Examples - Teiserver.Settings.UserSettingLib.update_user_setting/2","doc":"iex> update_user_setting(user_setting, %{field: new_value})\n    {:ok, %UserSetting{}}\n\n    iex> update_user_setting(user_setting, %{field: bad_value})\n    {:error, %Ecto.Changeset{}}","ref":"Teiserver.Settings.UserSettingLib.html#update_user_setting/2-examples"},{"type":"module","title":"Teiserver.Helpers.SchemaHelper","doc":"A set of functions for helping with schema files","ref":"Teiserver.Helpers.SchemaHelper.html"},{"type":"function","title":"Teiserver.Helpers.SchemaHelper.min_and_max/2","doc":"Given params and a pair of fields,\nensures the lower value of the two is assigned to the first\nfield and the higher value to the second.\n\n%{f1: 5, f2: 3}\n|> min_and_max(~w(f1 f2))\n\n> %{f1: 3, f2: 5}","ref":"Teiserver.Helpers.SchemaHelper.html#min_and_max/2"},{"type":"function","title":"Teiserver.Helpers.SchemaHelper.remove_characters/3","doc":"Given a list of fields and a list of patterns, will apply Regex.replace for every\npattern to each field.","ref":"Teiserver.Helpers.SchemaHelper.html#remove_characters/3"},{"type":"function","title":"Teiserver.Helpers.SchemaHelper.trim_strings/2","doc":"","ref":"Teiserver.Helpers.SchemaHelper.html#trim_strings/2"},{"type":"function","title":"Teiserver.Helpers.SchemaHelper.uniq_lists/2","doc":"Applied `Enum.uniq` to one or more fields in the params","ref":"Teiserver.Helpers.SchemaHelper.html#uniq_lists/2"},{"type":"module","title":"Teiserver.Config","doc":"Config struct\nAs with most things at this stage, heavily copied from Oban","ref":"Teiserver.Config.html"},{"type":"function","title":"Teiserver.Config.new/1","doc":"Generate a Config struct after normalizing and verifying Teiserver options.\n\nSee `Teiserver.start_link/1` for a comprehensive description of available options.","ref":"Teiserver.Config.html#new/1"},{"type":"function","title":"Example - Teiserver.Config.new/1","doc":"Generate a minimal config with only a `:repo`:\n\n    Teiserver.Config.new(repo: Teiserver.Test.Repo)","ref":"Teiserver.Config.html#new/1-example"},{"type":"function","title":"Teiserver.Config.validate/1","doc":"Verify configuration options.\n\nThis helper is used by `new/1`, and therefore by `Teiserver.start_link/1`, to verify configuration\noptions when a Teiserver supervisor starts. It is provided publicly to aid in configuration testing,\nas `test` config may differ from `prod` config.\n\n# Example\n\nValidating top level options:\n\n    iex> Teiserver.Config.validate(name: Teiserver)\n    :ok\n\n    iex> Teiserver.Config.validate(name: Teiserver, log: false)\n    :ok\n\n    iex> Teiserver.Config.validate(node: {:not, :binary})\n    {:error, \"expected :node to be a binary, got: {:not, :binary}\"}\n\nValidating plugin options:\n\n    iex> Teiserver.Config.validate(plugins: [{Teiserver.Plugins.Pruner, max_age: 60}])\n    :ok\n\n    iex> Teiserver.Config.validate(plugins: [{Teiserver.Plugins.Pruner, max_age: 0}])\n    {:error, \"invalid value for :plugins, expected :max_age to be a positive integer, got: 0\"}","ref":"Teiserver.Config.html#validate/1"},{"type":"type","title":"Teiserver.Config.t/0","doc":"","ref":"Teiserver.Config.html#t:t/0"},{"type":"behaviour","title":"Teiserver.Migration","doc":"Migrations create and modify the database tables Teiserver needs to function.","ref":"Teiserver.Migration.html"},{"type":"behaviour","title":"Usage - Teiserver.Migration","doc":"To use migrations in your application you'll need to generate an `Ecto.Migration` that wraps\ncalls to `Teiserver.Migration`:\n\n```bash\nmix ecto.gen.migration add_teiserver\n```\n\nOpen the generated migration in your editor and call the `up` and `down` functions on\n`Teiserver.Migration`:\n\n```elixir\ndefmodule MyApp.Repo.Migrations.AddTeiserver do\n  use Ecto.Migration\n\n  def up, do: Teiserver.Migrations.up()\n\n  def down, do: Teiserver.Migrations.down()\nend\n```\n\nThis will run all of Teiserver's versioned migrations for your database.\n\nNow, run the migration to create the table:\n\n```bash\nmix ecto.migrate\n```\n\nMigrations between versions are idempotent. As new versions are released, you may need to run\nadditional migrations. To do this, generate a new migration:\n\n```bash\nmix ecto.gen.migration upgrade_Teiserver_to_v1\n```\n\nOpen the generated migration in your editor and call the `up` and `down` functions on\n`Teiserver.Migration`, passing a version number:\n\n```elixir\ndefmodule MyApp.Repo.Migrations.UpgradeTeiserverToV1 do\n  use Ecto.Migration\n\n  def up, do: Teiserver.Migrations.up(version: 1)\n\n  def down, do: Teiserver.Migrations.down(version: 1)\nend\n```","ref":"Teiserver.Migration.html#module-usage"},{"type":"behaviour","title":"Isolation with Prefixes - Teiserver.Migration","doc":"Teiserver supports namespacing through PostgreSQL schemas, also called \"prefixes\" in Ecto. With\nprefixes your jobs table can reside outside of your primary schema (usually public) and you can\nhave multiple separate job tables.\n\nTo use a prefix you first have to specify it within your migration:\n\n```elixir\ndefmodule MyApp.Repo.Migrations.AddPrefixedTeiserverJobsTable do\n  use Ecto.Migration\n\n  def up, do: Teiserver.Migrations.up(prefix: \"private\")\n\n  def down, do: Teiserver.Migrations.down(prefix: \"private\")\nend\n```\n\nThe migration will create the \"private\" schema and all tables, functions and triggers within\nthat schema. With the database migrated you'll then specify the prefix in your configuration:\n\n```elixir\nconfig :my_app, Teiserver,\n  prefix: \"private\",\n  ...\n```\n\nIn some cases, for example if your \"private\" schema already exists and your database user in\nproduction doesn't have permissions to create a new schema, trying to create the schema from the\nmigration will result in an error. In such situations, it may be useful to inhibit the creation\nof the \"private\" schema:\n\n```elixir\ndefmodule MyApp.Repo.Migrations.AddPrefixedTeiserverJobsTable do\n  use Ecto.Migration\n\n  def up, do: Teiserver.Migrations.up(prefix: \"private\", create_schema: false)\n\n  def down, do: Teiserver.Migrations.down(prefix: \"private\")\nend\n```","ref":"Teiserver.Migration.html#module-isolation-with-prefixes"},{"type":"behaviour","title":"Migrating Without Ecto - Teiserver.Migration","doc":"If your application uses something other than Ecto for migrations, be it an external system or\nanother ORM, it may be helpful to create plain SQL migrations for Teiserver database schema changes.\n\nThe simplest mechanism for obtaining the SQL changes is to create the migration locally and run\n`mix ecto.migrate --log-migrations-sql`. That will log all of the generated SQL, which you can\nthen paste into your migration system of choice.","ref":"Teiserver.Migration.html#module-migrating-without-ecto"},{"type":"function","title":"Teiserver.Migration.down/1","doc":"Run the `down` changes for all migrations between the current version and the initial version.","ref":"Teiserver.Migration.html#down/1"},{"type":"function","title":"Example - Teiserver.Migration.down/1","doc":"Run all migrations from current version down to the first:\n\n    Teiserver.Migration.down()\n\nRun migrations down to and including a specified version:\n\n    Teiserver.Migration.down(version: 5)\n\nRun migrations in an alternate prefix:\n\n    Teiserver.Migration.down(prefix: \"game_server\")","ref":"Teiserver.Migration.html#down/1-example"},{"type":"callback","title":"Teiserver.Migration.down/1","doc":"Migrates storage down to the previous version.","ref":"Teiserver.Migration.html#c:down/1"},{"type":"function","title":"Teiserver.Migration.migrated_version/1","doc":"Check the latest version the database is migrated to.","ref":"Teiserver.Migration.html#migrated_version/1"},{"type":"function","title":"Example - Teiserver.Migration.migrated_version/1","doc":"Teiserver.Migration.migrated_version()","ref":"Teiserver.Migration.html#migrated_version/1-example"},{"type":"callback","title":"Teiserver.Migration.migrated_version/1","doc":"Identifies the last migrated version.","ref":"Teiserver.Migration.html#c:migrated_version/1"},{"type":"function","title":"Teiserver.Migration.up/1","doc":"Run the `up` changes for all migrations between the initial version and the current version.","ref":"Teiserver.Migration.html#up/1"},{"type":"function","title":"Example - Teiserver.Migration.up/1","doc":"Run all migrations up to the current version:\n\n    Teiserver.Migration.up()\n\nRun migrations up to a specified version:\n\n    Teiserver.Migration.up(version: 2)\n\nRun migrations in an alternate prefix:\n\n    Teiserver.Migration.up(prefix: \"game_server\")\n\nRun migrations in an alternate prefix but don't try to create the schema:\n\n    Teiserver.Migration.up(prefix: \"game_server\", create_schema: false)","ref":"Teiserver.Migration.html#up/1-example"},{"type":"callback","title":"Teiserver.Migration.up/1","doc":"Migrates storage up to the latest version.","ref":"Teiserver.Migration.html#c:up/1"},{"type":"module","title":"Teiserver.Registry","doc":"Local process storage for Teiserver instances.\nHeavily copied from Oban","ref":"Teiserver.Registry.html"},{"type":"function","title":"Teiserver.Registry.config/1","doc":"Fetch the config for an Teiserver supervisor instance.","ref":"Teiserver.Registry.html#config/1"},{"type":"function","title":"Example - Teiserver.Registry.config/1","doc":"Get the default instance config:\n\n    Teiserver.Registry.config(Teiserver)\n\nGet config for a custom named instance:\n\n    Teiserver.Registry.config(MyApp.Teiserver)","ref":"Teiserver.Registry.html#config/1-example"},{"type":"function","title":"Teiserver.Registry.lookup/2","doc":"Find the `{pid, value}` pair for a registered Teiserver process.","ref":"Teiserver.Registry.html#lookup/2"},{"type":"function","title":"Example - Teiserver.Registry.lookup/2","doc":"Get the default instance config:\n\n    Teiserver.Registry.lookup(Teiserver)\n\nGet a supervised module's pid:\n\n    Teiserver.Registry.lookup(Teiserver, Teiserver.Notifier)","ref":"Teiserver.Registry.html#lookup/2-example"},{"type":"function","title":"Teiserver.Registry.via/3","doc":"Build a via tuple suitable for calls to a supervised Teiserver process.","ref":"Teiserver.Registry.html#via/3"},{"type":"function","title":"Example - Teiserver.Registry.via/3","doc":"For an Teiserver supervisor:\n\n    Teiserver.Registry.via(Teiserver)\n\nFor a supervised module:\n\n    Teiserver.Registry.via(Teiserver, Teiserver.Notifier)\n\nFor a plugin:\n\n    Teiserver.Registry.via(Teiserver, {:plugin, Teiserver.Plugins.Cron})","ref":"Teiserver.Registry.html#via/3-example"},{"type":"function","title":"Teiserver.Registry.whereis/2","doc":"Returns the pid of a supervised Teiserver process, or `nil` if the process can't be found.","ref":"Teiserver.Registry.html#whereis/2"},{"type":"function","title":"Example - Teiserver.Registry.whereis/2","doc":"Get the Teiserver supervisor's pid:\n\n    Teiserver.Registry.whereis(Teiserver)\n\nGet a supervised module's pid:\n\n    Teiserver.Registry.whereis(Teiserver, Teiserver.Notifier)\n\nGet the pid for a plugin:\n\n    Teiserver.Registry.whereis(Teiserver, {:plugin, MyApp.Teiserver.Plugin})\n\nGet the pid for a queue's producer:\n\n    Teiserver.Registry.whereis(Teiserver, {:producer, \"default\"})","ref":"Teiserver.Registry.html#whereis/2-example"},{"type":"type","title":"Teiserver.Registry.key/0","doc":"","ref":"Teiserver.Registry.html#t:key/0"},{"type":"type","title":"Teiserver.Registry.role/0","doc":"","ref":"Teiserver.Registry.html#t:role/0"},{"type":"type","title":"Teiserver.Registry.value/0","doc":"","ref":"Teiserver.Registry.html#t:value/0"},{"type":"module","title":"Teiserver.Repo","doc":"Copied and tweaked from Oban.\n\nWrappers around `Ecto.Repo` and `Ecto.Adapters.SQL` callbacks.\n\nEach function resolves the correct repo instance and sets options such as `prefix` and `log`\naccording to `Teiserver.Config`.\n\n> ##","ref":"Teiserver.Repo.html"},{"type":"module","title":"Meant for Extending Teiserver {: .warning} - Teiserver.Repo","doc":">\n> These functions should only be used when working with a repo inside engines, plugins, or other\n> extensions for Teiserver. Favour using your application's repo directly when querying `Teiserver.Job`\n> from your workers.","ref":"Teiserver.Repo.html#module-meant-for-extending-teiserver-warning"},{"type":"module","title":"Examples - Teiserver.Repo","doc":"The first argument for every function must be an `Teiserver.Config` struct. Many functions pass\nconfiguration around as a `conf` key, and it can always be fetched with `Teiserver.config/1`. This\ndemonstrates fetching the default instance config and querying all jobs:\n\n    Teiserver\n    |> Teiserver.config()\n    |> Teiserver.Repo.all(Teiserver.Job)","ref":"Teiserver.Repo.html#module-examples"},{"type":"function","title":"Teiserver.Repo.aggregate/4","doc":"Wraps `c:Ecto.Repo.aggregate/3` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#aggregate/4"},{"type":"function","title":"Teiserver.Repo.all/3","doc":"Wraps `c:Ecto.Repo.all/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#all/3"},{"type":"function","title":"Teiserver.Repo.checkout/3","doc":"Wraps `c:Ecto.Repo.checkout/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#checkout/3"},{"type":"function","title":"Teiserver.Repo.config/1","doc":"Wraps `c:Ecto.Repo.config/0` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#config/1"},{"type":"function","title":"Teiserver.Repo.default_options/1","doc":"The default values extracted from `Teiserver.Config` for use in all queries with options.","ref":"Teiserver.Repo.html#default_options/1"},{"type":"function","title":"Teiserver.Repo.default_options/2","doc":"Wraps `c:Ecto.Repo.default_options/1` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#default_options/2"},{"type":"function","title":"Teiserver.Repo.delete/3","doc":"Wraps `c:Ecto.Repo.delete/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#delete/3"},{"type":"function","title":"Teiserver.Repo.delete!/3","doc":"Wraps `c:Ecto.Repo.delete!/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#delete!/3"},{"type":"function","title":"Teiserver.Repo.delete_all/3","doc":"Wraps `c:Ecto.Repo.delete_all/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#delete_all/3"},{"type":"function","title":"Teiserver.Repo.exists?/3","doc":"Wraps `c:Ecto.Repo.exists?/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#exists?/3"},{"type":"function","title":"Teiserver.Repo.get/4","doc":"Wraps `c:Ecto.Repo.get/3` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#get/4"},{"type":"function","title":"Teiserver.Repo.get!/4","doc":"Wraps `c:Ecto.Repo.get!/3` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#get!/4"},{"type":"function","title":"Teiserver.Repo.get_by/4","doc":"Wraps `c:Ecto.Repo.get_by/3` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#get_by/4"},{"type":"function","title":"Teiserver.Repo.get_by!/4","doc":"Wraps `c:Ecto.Repo.get_by!/3` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#get_by!/4"},{"type":"function","title":"Teiserver.Repo.get_dynamic_repo/1","doc":"Wraps `c:Ecto.Repo.get_dynamic_repo/0` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#get_dynamic_repo/1"},{"type":"function","title":"Teiserver.Repo.in_transaction?/1","doc":"Wraps `c:Ecto.Repo.in_transaction?/0` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#in_transaction?/1"},{"type":"function","title":"Teiserver.Repo.insert/3","doc":"Wraps `c:Ecto.Repo.insert/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#insert/3"},{"type":"function","title":"Teiserver.Repo.insert!/3","doc":"Wraps `c:Ecto.Repo.insert!/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#insert!/3"},{"type":"function","title":"Teiserver.Repo.insert_all/4","doc":"Wraps `c:Ecto.Repo.insert_all/3` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#insert_all/4"},{"type":"function","title":"Teiserver.Repo.insert_or_update/3","doc":"Wraps `c:Ecto.Repo.insert_or_update/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#insert_or_update/3"},{"type":"function","title":"Teiserver.Repo.insert_or_update!/3","doc":"Wraps `c:Ecto.Repo.insert_or_update!/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#insert_or_update!/3"},{"type":"function","title":"Teiserver.Repo.load/3","doc":"Wraps `c:Ecto.Repo.load/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#load/3"},{"type":"function","title":"Teiserver.Repo.one/3","doc":"Wraps `c:Ecto.Repo.one/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#one/3"},{"type":"function","title":"Teiserver.Repo.one!/3","doc":"Wraps `c:Ecto.Repo.one!/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#one!/3"},{"type":"function","title":"Teiserver.Repo.preload/4","doc":"Wraps `c:Ecto.Repo.preload/3` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#preload/4"},{"type":"function","title":"Teiserver.Repo.put_dynamic_repo/2","doc":"Wraps `c:Ecto.Repo.put_dynamic_repo/1` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#put_dynamic_repo/2"},{"type":"function","title":"Teiserver.Repo.query/4","doc":"Wraps `Ecto.Adapters.SQL.Repo.query/4` with an added `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#query/4"},{"type":"function","title":"Teiserver.Repo.query!/4","doc":"Wraps `Ecto.Adapters.SQL.Repo.query!/4` with an added `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#query!/4"},{"type":"function","title":"Teiserver.Repo.reload/3","doc":"Wraps `c:Ecto.Repo.reload/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#reload/3"},{"type":"function","title":"Teiserver.Repo.reload!/3","doc":"Wraps `c:Ecto.Repo.reload!/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#reload!/3"},{"type":"function","title":"Teiserver.Repo.rollback/2","doc":"Wraps `c:Ecto.Repo.rollback/1` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#rollback/2"},{"type":"function","title":"Teiserver.Repo.stream/3","doc":"Wraps `c:Ecto.Repo.stream/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#stream/3"},{"type":"function","title":"Teiserver.Repo.to_sql/3","doc":"Wraps `Ecto.Adapters.SQL.Repo.to_sql/2` with an added `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#to_sql/3"},{"type":"function","title":"Teiserver.Repo.transaction/3","doc":"Wraps `c:Ecto.Repo.transaction/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#transaction/3"},{"type":"function","title":"Teiserver.Repo.update/3","doc":"Wraps `c:Ecto.Repo.update/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#update/3"},{"type":"function","title":"Teiserver.Repo.update!/3","doc":"Wraps `c:Ecto.Repo.update!/2` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#update!/3"},{"type":"function","title":"Teiserver.Repo.update_all/4","doc":"Wraps `c:Ecto.Repo.update_all/3` with an additional `Teiserver.Config` argument.","ref":"Teiserver.Repo.html#update_all/4"},{"type":"module","title":"TeiserverMacros","doc":"A set of macros for defining common file types.\n\nThis can be used in your application as:\n\n    use TeiserverMacros, :queries\n    use TeiserverMacros, :library","ref":"TeiserverMacros.html"},{"type":"macro","title":"TeiserverMacros.__using__/1","doc":"When used, dispatch to the appropriate controller/view/etc.","ref":"TeiserverMacros.html#__using__/1"},{"type":"function","title":"TeiserverMacros.library/0","doc":"","ref":"TeiserverMacros.html#library/0"},{"type":"function","title":"TeiserverMacros.queries/0","doc":"","ref":"TeiserverMacros.html#queries/0"},{"type":"function","title":"TeiserverMacros.schema/0","doc":"","ref":"TeiserverMacros.html#schema/0"},{"type":"extras","title":"Changelog","doc":"","ref":"changelog.html"},{"type":"extras","title":"v0.0.1 - Changelog","doc":"-","ref":"changelog.html#v0-0-1"},{"type":"extras","title":"Installation","doc":"# Installation\nA middleware server library.","ref":"installation.html"},{"type":"extras","title":"Dependency - Installation","doc":"First add to your dependencies in `mix.exs`.\n```elixir\ndef deps do\n  [\n    {:teiserver, \"~> 0.0.1\"}\n  ]\nend\n```","ref":"installation.html#dependency"},{"type":"extras","title":"Migration - Installation","doc":"Now add a migration\n```bash\nmix ecto.gen.migration add_teiserver_tables\n```\n\nOpen the generated migration and add the below code:\n```elixir\ndefmodule MyApp.Repo.Migrations.AddTeiserverTables do\n  use Ecto.Migration\n\n  def up do\n    Teiserver.Migration.up()\n  end\n\n  # We specify `version: 1` in `down`, ensuring that we'll roll all the way back down if\n  # necessary, regardless of which version we've migrated `up` to.\n  def down do\n    Teiserver.Migration.down(version: 1)\n  end\nend\n```","ref":"installation.html#migration"},{"type":"extras","title":"Supervision tree - Installation","doc":"Add this to your Application supervision tree:\n```elixir\nchildren = [\n  {Teiserver, Application.get_env(:my_app, Teiserver)}\n]\n```","ref":"installation.html#supervision-tree"},{"type":"extras","title":"Config - Installation","doc":"In `config.exs`\n```elixir\nconfig :hello_world_server, Teiserver,\n  repo: HelloWorldServer.Repo\n```","ref":"installation.html#config"},{"type":"extras","title":"Hello World","doc":"# Hello World\nThe purpose of this guide is to show you how to create a very basic server implementing the commands `ping`, `register`, `login`, `whois`, `whoami`, `users` and `clients`. We will be using ranch to provide a plain-text interface to our server though for real projects you'll typically want something more structured than just plain-text.","ref":"hello_world.html"},{"type":"extras","title":"Create project - Hello World","doc":"```bash\nmix new --sup hello_world_server\n```","ref":"hello_world.html#create-project"},{"type":"extras","title":"Add dependencies - Hello World","doc":"In `mix.exs`\n```elixir\ndef deps do\n  [\n    {:teiserver, path: \"../teiserver\"},\n    {:ecto_sql, \"~> 3.10\"},\n    {:postgrex, \">= 0.0.0\"},\n    {:ranch, \"~> 1.8\"}\n  ]\nend\n```\n\nNow get the relevant dependencies\n\n```bash\nmix deps.get && mix compile\n```","ref":"hello_world.html#add-dependencies"},{"type":"extras","title":"Create a migration - Hello World","doc":"```bash\nmix ecto.gen.migration add_teiserver_tables\n```\n\nAnd populate it like so:\n```elixir\ndefmodule HelloWorldServer.Repo.Migrations.AddTeiserverTables do\n  use Ecto.Migration\n\n  def up do\n    Teiserver.Migration.up()\n  end\n\n  def down do\n    Teiserver.Migration.down(version: 1)\n  end\nend\n```","ref":"hello_world.html#create-a-migration"},{"type":"extras","title":"Application files - Hello World","doc":"`lib/hello_world_server/repo.ex`\n```elixir\ndefmodule HelloWorldServer.Repo do\n  use Ecto.Repo,\n    otp_app: :hello_world_server,\n    adapter: Ecto.Adapters.Postgres\nend\n```\n\n`config/config.exs`\n```elixir\nimport Config\n\nconfig :hello_world_server,\n  ecto_repos: [HelloWorldServer.Repo]\n\nconfig :hello_world_server, HelloWorldServer.Repo,\n  database: \"hello_world_server\",\n  username: \"postgres\",\n  password: \"postgres\",\n  hostname: \"localhost\"\n\nconfig :hello_world_server, Teiserver,\n  repo: HelloWorldServer.Repo\n```\n\nEdit `application.ex` to start the various components on startup.\n```elixir\n  children = [\n    HelloWorldServer.Repo,\n    {Ecto.Migrator,\n        repos: Application.fetch_env!(:hello_world_server, :ecto_repos),\n        skip: System.get_env(\"SKIP_MIGRATIONS\") == \"true\"},\n    {Teiserver, Application.get_env(:hello_world_server, Teiserver)},\n    %{\n      id: HelloWorldServer.TcpServer,\n      start: {HelloWorldServer.TcpServer, :start_link, [[]]}\n    }\n  ]\n```","ref":"hello_world.html#application-files"},{"type":"extras","title":"Add our tcp server - Hello World","doc":"Place in `lib/hello_world_server/tcp_server.ex`\n```elixir\ndefmodule HelloWorldServer.TcpServer do\n  use GenServer\n  alias HelloWorldServer.{TcpIn, TcpOut}\n  @behaviour :ranch_protocol\n\n  def start_link(_opts) do\n    :ranch.start_listener(\n      make_ref(),\n      :ranch_tcp,\n      [port: 8200],\n      __MODULE__,\n      []\n    )\n  end\n\n  @impl true\n  def start_link(ref, socket, transport, _opts) do\n    pid = :proc_lib.spawn_link(__MODULE__, :init, [ref, socket, transport])\n    {:ok, pid}\n  end\n\n  def init(ref, socket, transport) do\n    :ranch.accept_ack(ref)\n    transport.setopts(socket, [{:active, true}])\n\n    state = %{\n      user_id: nil,\n      socket: socket,\n      transport: transport,\n    }\n\n    :gen_server.enter_loop(__MODULE__, [], state)\n  end\n\n  @impl true\n  def init(init_arg) do\n    {:ok, init_arg}\n  end\n\n  @impl true\n  def handle_info(:init_timeout, %{userid: nil} = state) do\n    send(self(), :terminate)\n    {:noreply, state}\n  end\n\n  def handle_info(:init_timeout, state) do\n    {:noreply, state}\n  end\n\n  # If Ctrl + C is sent through it kills the connection, makes telnet debugging easier\n  def handle_info({_, _socket, <<255, 244, 255, 253, 6>>}, state) do\n    send(self(), :terminate)\n    {:noreply, state}\n  end\n\n  def handle_info({:tcp, _socket, data}, state) do\n    data = data\n    |> to_string\n    |> String.trim\n\n    {new_state, response} = TcpIn.data_in(data, state)\n    TcpOut.data_out(response, state)\n    {:noreply, new_state}\n  end\nend\n```","ref":"hello_world.html#add-our-tcp-server"},{"type":"extras","title":"Data in - Hello World","doc":"Place in `lib/hellow_world_server/tcp_in.ex`, this will handle all the commands coming in.\n```elixir\ndefmodule HelloWorldServer.TcpIn do\n  def data_in(\"ping\" <> _data, state) do\n    {state, \"pong\"}\n  end\n\n  def data_in(\"login \" <> data, state) do\n    [name, password] = String.split(data, \" \")\n    case Teiserver.Account.get_user_by_name(name) do\n      nil ->\n        {state, \"Login failed (no user)\"}\n      user ->\n        if Teiserver.Account.verify_user_password(user, password) do\n          Teiserver.Connections.login_user(user)\n          {%{state | user_id: user.id}, \"You are now logged in as '#{user.name}'\"}\n        else\n          {state, \"Login failed (bad password)\"}\n        end\n    end\n  end\n\n  def data_in(\"register \" <> data, state) do\n    [name, password] = String.split(data, \" \")\n    params = %{\n      \"name\" => name,\n      \"password\" => password,\n\n      # We're not using emails right now but Teiserver expects them to be unique\n      # this will do for the purposes of this example\n      \"email\" => to_string(:rand.uniform())\n    }\n\n    case Teiserver.Account.create_user(params) do\n      {:ok, _user} ->\n        {state, \"User created, you can now login with 'login name password'\"}\n      {:error, _} ->\n        {state, \"Error registering user\"}\n    end\n  end\n\n  def data_in(\"whois \" <> data, state) do\n    case Teiserver.Account.get_user_by_name(data) do\n      nil ->\n        {state, \"I cannot find a user by the name of '#{data}'\"}\n      user ->\n        {state, \"User #{user.name} exists with an ID of #{user.id}\"}\n    end\n  end\n\n  def data_in(\"whoami\" <> _data, %{user_id: user_id} = state) do\n    case Teiserver.Account.get_user_by_id(user_id) do\n      nil ->\n        {state, \"You are not logged in\"}\n      user ->\n        {state, \"You are '#{user.name}'\"}\n    end\n  end\n\n  def data_in(\"users\" <> _data, %{user_id: user_id} = state) do\n    names = Teiserver.Account.list_users(select: [:name])\n    |> Enum.map(fn %{name: name} -> name end)\n    |> Enum.join(\", \")\n\n    {state, \"User names: #{names}\"}\n  end\n\n  def data_in(\"clients\" <> _data, %{user_id: user_id} = state) do\n    client_ids = Teiserver.Connections.list_client_ids()\n\n    names = Teiserver.Account.list_users(where: [id_in: client_ids], select: [:name])\n    |> Enum.map(fn %{name: name} -> name end)\n    |> Enum.join(\", \")\n\n    {state, \"Client names: #{names}\"}\n  end\nend\n```","ref":"hello_world.html#data-in"},{"type":"extras","title":"Data out - Hello World","doc":"Place in `lib/hellow_world_server/tcp_out.ex`, this will handle sending data back to our users.\n```elixir\ndefmodule HelloWorldServer.TcpOut do\n  def data_out(msg, state) do\n    state.transport.send(state.socket, msg <> \"\\n\")\n  end\nend\n```\n\n# Showtime!\nGet deps\nWe now need to run our application.\n```bash\nmix run --no-halt\n```\n\nIn another terminal we can then do:\n```bash\ntelnet localhost 8200\n# Trying 127.0.0.1...\n# Connected to localhost.\n# Escape character is '^]'.\n\nping\n# pong\n\nwhoami\n# You are not logged in\n\nwhois teifion\n# I cannot find a user by the name of 'Teifion'\n\nregister teifion password1\n# User created, you can now login with 'login name password'\n\nwhois teifion\n# User Teifion exists with an ID of 1\n\nlogin teifion nopass\n# Login failed (bad password)\n\nlogin teifion password1\n# You are now logged in as Teifion\n\nwhoami\n# You are 'Teifion'\n\nregister bob password1\n# User created, you can now login with 'login name password'\n\nusers\n# User names: teifion, bob\n\nclients\n# Client names: teifion\n```","ref":"hello_world.html#data-out"},{"type":"extras","title":"Library interaction","doc":"# Library interaction","ref":"program_schema.html"},{"type":"extras","title":"User to Teiserver - Library interaction","doc":"The expectation is your users will have an application running on their machine, this application will connect to your endpoint (websocket, grpc, plaintext etc). Your endpoint will be an Elixir application running Teiserver as a dependency and making the calls to it.\n\n```mermaid\ngraph TD;\n    app[User application] <--> Endpoint;\n    Endpoint --> CommandIn[Command dispatch];\n    CommandIn --> HandleIn[Command handler];\n    HandleIn --> Teiserver;\n    Teiserver --> HandleOut[Response handler];\n    HandleOut --> Endpoint;\n```","ref":"program_schema.html#user-to-teiserver"},{"type":"extras","title":"Snippets","doc":"# Snippets","ref":"snippets.html"},{"type":"extras","title":"User authentication and login - Snippets","doc":"Given a `name` and `password` we want to log a user in.\n\n```elixir\n@spec login_user(String.t(), String.t()) :: {:ok, Teiserver.Account.User.t()} | {:error, String.t()}\ndef login_user(name, password) do\n  case Teiserver.Account.get_user_by_name(name) do\n    nil ->\n      {:error, \"User not found\"}\n    user ->\n      if Teiserver.Account.verify_user_password(user, password) do\n        Teiserver.Connections.login_user(user)\n        {:ok, user}\n      else\n        {:error, \"Invalid password\"}\n      end\n  end\nend\n```","ref":"snippets.html#user-authentication-and-login"},{"type":"extras","title":"User logout - Snippets","doc":"```elixir\nTeiserver.Connections.disconnect_user(user)\n```","ref":"snippets.html#user-logout"},{"type":"extras","title":"Feature list","doc":"# Feature list","ref":"features.html"},{"type":"extras","title":"Accounts - Feature list","doc":"#","ref":"features.html#accounts"},{"type":"extras","title":"Users - Feature list","doc":"- Create, Read, Update, Delete\n- Password verification/storage\n- Free-form extra data fields","ref":"features.html#users"},{"type":"extras","title":"Connections - Feature list","doc":"#","ref":"features.html#connections"},{"type":"extras","title":"Clients - Feature list","doc":"- Tracking","ref":"features.html#clients"},{"type":"extras","title":"Settings - Feature list","doc":"- Site settings\n- User settings","ref":"features.html#settings"},{"type":"extras","title":"Roadmap","doc":"# Roadmap","ref":"roadmap.html"},{"type":"extras","title":"v0.1 plan - Roadmap","doc":"I want potential users to see the library and understand why they might want to use it and be able to use it.\n\n- Accounts\n  - Users\n  - User settings\n\n- Connections\n  - Clients (connect, disconnect, update)\n\n- Settings\n  - Site settings\n  - User settings\n\n- Telemetry\n  - In game events\n  - Server events\n  - Lobby events\n  - User events","ref":"roadmap.html#v0-1-plan"},{"type":"extras","title":"Planned/intended features - Roadmap","doc":"- Administration\n  - Moderation\n  - Analytics and Reporting\n- Accounts\n  - Users\n  - User settings\n  - Achievements\n  - Accolades (player awarded badges)\n- Communication\n  - Chat rooms\n  - Direct messages\n- Community\n  - Player relationships (e.g. friends)\n  - Player feedback system\n  - News/Miniblog\n  - Clans\n- Game related\n  - Lobbies\n  - Match history\n  - Leaderboards\n  - Matchmaking\n- Telemetry\n  - In game events\n  - Server events\n  - Lobby events\n  - User events\n- Integrations\n  - Steam\n  - Itch.io","ref":"roadmap.html#planned-intended-features"},{"type":"extras","title":"Other desired features - Roadmap","doc":"These might be placed into their own library.\n\n- Social media\n  - Discord\n\n- Admin web interface","ref":"roadmap.html#other-desired-features"}],"content_type":"text/markdown"}